#!/bin/csh 
#PBS -o /data4/support/Liliana/DYNA_Intro_Course/Course_Dec19-21/example4/ANSWER_BLOCK1/answer_block1.log
#PBS -e /data4/support/Liliana/DYNA_Intro_Course/Course_Dec19-21/example4/ANSWER_BLOCK1/answer_block1.err
#PBS -q dyna
#PBS -l nodes=1:ppn=2:dyna
#PBS -m abe
#
# License file variables
#
if(! $?OA_INSTALL) then
  setenv OA_INSTALL /data4/dyna10/rhe4_64_executables
endif
setenv LSTC_LICENSE_SERVER vdgsrv01
setenv LSTC_NOCLIENT ON
setenv LSTC_LICENSE network
setenv LSTC_MEMORY auto
setenv LM_LICENSE_FILE @vdgsrv01:@atgsrv01
#
# Job variables
#
setenv LSDYNA_VERSION /prg/LINUX/DYNA_EXECUTABLES/dyna_971_R4.2.1/ls971_s_R4_2_1_xeon64_redhat52.exe
setenv LSDYNA_MPP FALSE
setenv LSDYNA_HYBRID FALSE
setenv LSDYNA_DOUBLE FALSE 
setenv LSDYNA_ONLINE FALSE
setenv LSDYNA_BACKGROUND FALSE
setenv LSDYNA_BATCH FALSE
setenv LSDYNA_QUEUE TRUE
setenv LSDYNA_JOB_DIR /data4/support/Liliana/DYNA_Intro_Course/Course_Dec19-21/example4/ANSWER_BLOCK1
setenv LSDYNA_JOB_FILE answer_block1.temp
setenv LSDYNA_JOB_CPUS 2
setenv LSDYNA_HYBRID_MPP_THREADS 1
setenv LSDYNA_HYBRID_SMP_THREADS 1
setenv LSDYNA_USER_ID lbeldie
setenv LSDYNA_CASE_OPTION FALSE
setenv LSDYNA_MCHECK_OPTION FALSE
setenv LSDYNA_NOWAIT_OPTION FALSE
#
# Change to Job Directory
#
pushd /data4/support/Liliana/DYNA_Intro_Course/Course_Dec19-21/example4/ANSWER_BLOCK1
rm -f messag
rm -f mes[0-9][0-9][0-9][0-9]
rm -f messag[0-9][0-9][0-9][0-9]
rm -f dyna.d
rm -f disk8*
rm -f status.out
#
#
# The following Environment Variables are available for this script
#
# $LSDYNA_VERSION       :       full pathname of selected LS-DYNA executable
# $LSDYNA_MPP           :       TRUE if MPP version selected
# $LSDYNA_MPI_TYPE      :       MPI version
# $LSDYNA_DOUBLE        :       TRUE if double precision version selected
# $LSDYNA_ONLINE        :       TRUE if the job has been submitted ONLINE
# $LSDYNA_BACKGROUND    :       TRUE if the job has been submitted to BACKGROUND
# $LSDYNA_BATCH         :       TRUE if the job has been submitted using BATCH
# $LSDYNA_QUEUE         :       TRUE if the job has been submitted to a QUEUE
# $LSDYNA_JOB_DIR       :       full path of LS-DYNA job_directory
# $LSDYNA_JOB_FILE      :       filename containing LS-DYNA job options
# $LSDYNA_JOB_CPUS      :       number of CPU's selected
# $LSDYNA_USER_ID       :       username
# $LSDYNA_LOCAL_HOST    :       TRUE if submitting MPP jobs to the local machine
# $LSDYNA_NODE_FILE     :       TRUE if submitting MPP jobs using a Node File
# $NODE_FILE            :       filename containing node list for MPP jobs
# $LSDYNA_LOCAL_HOST    :       TRUE if submitting MPP jobs using a Node List
# $NODE_LIST            :       string containing node list for MPP jobs
# $LSDYNA_CASE_OPTION   :       TRUE if adding the 'case' option to the command line
# $LSDYNA_MCHECK_OPTION :       TRUE if adding the 'mcheck' option to the command line
# $LSDYNA_NOWAIT_OPTION :       TRUE if adding the 'nowait' option to the command line
# $LSDYNA_HYBRID        :       TRUE if HYBRID version selected
# $LSDYNA_MPP_THREADS   :       Number of MPP threads selected for the HYBRID version
# $LSDYNA_SMP_THREADS   :       Number of SMP threads selected for the HYBRID version
#
#
# 
# ============================================================================================
# MACHINE SPECIFIC VARIABLES   -  uncomment as required
#
#
# IBM AIX
# -------
# setenv YIELDLOOPTIME 10000000
# setenv SPINLOOPTIME  1000000
# setenv AIXTHREAD_SCOPE S
# setenv MP_PROCS $LSDYNA_JOB_CPUS
# setenv MP_LABELIO no
# setenv MP_EUILIB us
# setenv MP_EUIDEVICE css0
#
#
# SGI IRIX
# --------
# setenv MPC_GANG off
# setenv OMP_DYNAMIC FALSE
# setenv OMP_SET_NUMTHREADS $LSDYNA_JOB_CPUS
# setenv _DSM_PPM 2
# setenv _DSM_PLACEMENT ROUND_ROBIN
# setenv TRAP_FPE  "OVERFL=ABORT; DIVZERO=ABORT; INVALID=ABORT; INT_OVERFL=ABORT"
#
# ============================================================================================
#
#
# ============================================================================================
# MACHINE SPECIFIC MPP submission commands
#
# # HP ALPHA
# --------
# dmpirun -np $LSDYNA_JOB_CPUS $LSDYNA_VERSION
#
#
# HP PA8000 and Itanium2 (HP-MPI)
# ----------------------
# mpirun -np $LSDYNA_JOB_CPUS $LSDYNA_VERSION < $LSDYNA_JOB_FILE        (single node)
#
# mpirun -f appfile     (multiple nodes)
#        where appfile contains
#
#       -h hostname_1st -np #1 -e MPI_WORKDIR=<workdir> $LSDYNA_VERSION < $LSDYNA_JOB_FILE
#       -h hostname_2nd -np #2 -e MPI_WORKDIR=<workdir> $LSDYNA_VERSION
#       -h hostname_3rd -np #3 -e MPI_WORKDIR=<workdir> $LSDYNA_VERSION
#       -h hostname_4th -np #4 -e MPI_WORKDIR=<workdir> $LSDYNA_VERSION
#
#
# IBM Power
# ---------
# setenv MP_PROCS $LSDYNA_JOB_CPUS
# setenv MP_LABELIO no
# setenv MP_EUILIB us
# setenv MP_EUIDEVICE css0
#
# poe $LSDYNA_VERSION -procs $LSDYNA_JOB_CPUS -hfile $LSDYNA_NODE_FILE
#
#
# SGI IRIX
# --------
# mpirun -np $LSDYNA_JOB_CPUS $LSDYNA_VERSION
#
#
# SUN SPARC
# ---------
# mpirun -np $LSDYNA_JOB_CPUS $LSDYNA_VERSION
#
#
# ============================================================================================
#
#
# ********************************************************************************************
#
# THE REST OF THIS SCRIPT HAS BEEN CONFIGURED FOR SUBMITING LS-DYNA JOBS TO A LINUX SYSTEM USING
# THE PBS QUEUEING SYSTEM.  YOU WILL HAVE TO MODIFY THE FOLLOWING IF YOU ARE USING A DIFFERENT
# QUEUEING STSTEM OR MACHINE TYPE.
#
# ********************************************************************************************
#
#
# Command line options:
#
#
  if ($LSDYNA_CASE_OPTION == "TRUE") then
    set case = "case"
  else
    set case = ""
  endif
#
  if ($LSDYNA_MCHECK_OPTION == "TRUE") then
    set mcheck = "mcheck=yes"
  else
    set mcheck = ""
  endif
#
  if ($LSDYNA_NOWAIT_OPTION == "TRUE") then
    set nowait = "nowait"
  else
    set nowait = ""
  endif
#
#
if ( $LSDYNA_MPP !=  "TRUE" && $LSDYNA_HYBRID != "TRUE") then
#
# ======================
# SMP LS-DYNA submission
# ======================
#
  $LSDYNA_VERSION $case $mcheck $nowait < $LSDYNA_JOB_DIR/$LSDYNA_JOB_FILE
#
else if ($LSDYNA_MPP == "TRUE") then
#
# Create a PFILE which forces the scratch files to a local directory
#
  if ($LSDYNA_QUEUE == "TRUE") then
    rm -rf pfile
    echo "directory {" > pfile
    echo "transfer_files" >> pfile
    echo "local /local/$PBS_JOBID" >> pfile
    echo "rmlocal" >> pfile
    echo "}" >> pfile
    echo "general {" >> pfile
    echo "nofull" >> pfile
    echo "}" >> pfile
    #rm -f names
    /data3/SCRIPTS/modify_names.exe $LSDYNA_JOB_FILE
    set pfile_created = "TRUE"
  else
    set pfile_created = "FALSE"
  endif
# ======================
# MPP LS-DYNA submission
# ======================
#
# HP-MPI
#
  if ($LSDYNA_MPI_TYPE == "HP-MPI") then
#
    setenv HPMPI_DIR /opt/hpmpi/bin
#
    if ($LSDYNA_QUEUE == "TRUE") then
#
      if (-e $PBS_NODEFILE) then
        rm -rf $LSDYNA_JOB_DIR/appfile >& /dev/null
        if (-f $PBS_NODEFILE) then
          foreach roger ( `cat $PBS_NODEFILE` )
            echo "-h $roger -np 1 $LSDYNA_VERSION" $case $mcheck $nowait >> $LSDYNA_JOB_DIR/appfile
            set case = ""
            set mcheck = ""
            set nowait = ""
          end
        endif
      endif
      $HPMPI_DIR/mpirun -cpu_bind -prot -e MPI_WORKDIR=$LSDYNA_JOB_DIR -f  appfile
#      rm -rf $LSDYNA_JOB_DIR/appfile >& /dev/null
#
    else if ($LSDYNA_ONLINE == "TRUE") then
#
      if ($LSDYNA_LOCAL_HOST == "TRUE") then
#
         $HPMPI_DIR/mpirun -prot -np $LSDYNA_JOB_CPUS $LSDYNA_VERSION
#
      else if ($LSDYNA_NODE_FILE == "TRUE") then
#
         $HPMPI_DIR/mpirun -prot -np $LSDYNA_JOB_CPUS -hostfile $NODE_FILE -e LSTC_LICENSE_SERVER=$LSTC_LICENSE_SERVER -e LSTC_LICENSE=$LSTC_LICENSE $LSDYNA_VERSION
#
      else if ($LSDYNA_NODE_LIST == "TRUE") then
#
         $HPMPI_DIR/mpirun -prot -np $LSDYNA_JOB_CPUS -hostlist $NODE_LIST -e LSTC_LICENSE_SERVER=$LSTC_LICENSE_SERVER -e LSTC_LICENSE=$LSTC_LICENSE $LSDYNA_VERSION
#
      endif
#
    endif
#
# LAM 6.5.9 - using ssh
#
  else if ($LSDYNA_MPI_TYPE == "LAM659") then
#
    setenv LAM_DIR /usr/local/lam_6-5-9/bin
    setenv LAMRSH "ssh -x"
    $LAM_DIR/recon -v $PBS_NODEFILE
    $LAM_DIR/lamboot -v $PBS_NODEFILE
    $LAM_DIR/mpirun C $LSDYNA_VERSION < $LSDYNA_JOB_DIR/$LSDYNA_JOB_FILE
    $LAM_DIR/lamclean
    $LAM_DIR/wipe $PBS_NODEFILE
#
# LAM 7.0.3 - using ssh
#
  else if ($LSDYNA_MPI_TYPE == "LAM703") then
#
    setenv LAM_DIR /usr/local/lam_7-0-3/bin
    setenv LAMRSH "ssh -x"
    $LAM_DIR/recon -v $PBS_NODEFILE
    $LAM_DIR/lamboot -v -ssi boot rsh -ssi boot_rsh_agent "ssh -x" $PBS_NODEFILE
    $LAM_DIR/mpirun C -x LD_LIBRARY_PATH $LSDYNA_VERSION < $LSDYNA_JOB_DIR/$LSDYNA_JOB_FILE
    $LAM_DIR/bin/lamclean
    $LAM_DIR/wipe $PBS_NODEFILE
#  
# MPICH 1.2.6 - using ssh
#
  else if ($LSDYNA_MPI_TYPE == "MPICH") then
#
    setenv MPICH_DIR /usr/local/mpich_1-2-6/bin
    if (-e $PBS_NODEFILE) then
      cat  $PBS_NODEFILE
      set  numproc = `cat $PBS_NODEFILE | wc -l `
    endif
    setenv P4_RSHCOMMAND "ssh -x"
    $MPICH_DIR/mpirun -np $numproc  $LSDYNA_VERSION < $LSDYNA_JOB_DIR/$LSDYNA_JOB_FILE 
#
  endif
#
  if ( $pfile_created == "TRUE" ) then
    rm -rf pfile
  endif
#
else if ($LSDYNA_HYBRID == "TRUE") then
#
# =========================
# HYBRID LS-DYNA submission
# =========================
#
# HP-MPI
#
  if ($LSDYNA_MPI_TYPE == "HP-MPI") then
#
    setenv HPMPI_DIR /opt/hpmpi/bin
#
    if ($LSDYNA_QUEUE == "TRUE") then
#
      if (-e $PBS_NODEFILE) then
        rm -rf $LSDYNA_JOB_DIR/appfile >& /dev/null
        if (-f $PBS_NODEFILE) then
          foreach roger ( `sort -u $PBS_NODEFILE` )
            echo "-h $roger -np 1 $LSDYNA_VERSION" $case $mcheck $nowait >> $LSDYNA_JOB_DIR/appfile
            set case = ""
            set mcheck = ""
            set nowait = ""
          end
        endif
      endif
      $HPMPI_DIR/mpirun -cpu_bind -prot -e MPI_WORKDIR=$LSDYNA_JOB_DIR -f  appfile
#     rm -rf $LSDYNA_JOB_DIR/appfile >& /dev/null
    endif
#
  endif
#
endif
#
setenv REPORTER_NO_BATCH_OASYS 1
#
# PRIMER 'ztf' file creation
#
/data4/dyna10/rhe4_64_executables/primer10_64.exe -d=batch -ztf=/data4/support/Liliana/DYNA_Intro_Course/Course_Dec19-21/example4/ANSWER_BLOCK1/answer_block1.key > /data4/support/Liliana/DYNA_Intro_Course/Course_Dec19-21/example4/ANSWER_BLOCK1/answer_block1.ztf_log 
#
# Set DISPLAY
#
setenv DISPLAY 10.149.48.17:0
rm -f dyna.d
rm -f disk8*
